﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
    
using System.Data.OleDb;
    
namespace FormsADO
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }
    
        String ConnectionString(String fileNameNotExt)
        {
            string JetEngineString = @"Provider=Microsoft.Jet.OLEDB.4.0;Jet OLEDB:Engine Type=5;Data Source=";
            string pathToFile = Application.StartupPath.ToString() + "\\Data\\";
            return JetEngineString + pathToFile + fileNameNotExt.Trim() + ".mdb";
        }
    
        private void Form1_Load(object sender, EventArgs e)
        {
            // Настраиваем объект команд 
            oleDbSelectCommand1.CommandText = "SELECT CustomerID, CompanyName FROM  Customers\r\n"
                + "WHERE (CompanyName LIKE ? + '%')";
            oleDbSelectCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter());
            oleDbSelectCommand1.Parameters[0].Value = "A";
    
            // Задаем строку соединения
            oleDbConnection1.ConnectionString = ConnectionString("Northwind");
    
            // Заполняем набор данных настроенным адаптером данных 
            //oleDbDataAdapter1.Fill(dataSet11);
            SafeFill_1();
    
            // Устанавливаем курсор списка в конец
            listBox.SelectedIndex = listBox.Items.Count - 1;
        }
    
        private void btnLoadList_Click(object sender, EventArgs e)
        {
            NewLoad();
        }
    
        void NewLoad()
        {
            // Извлекаем значение текстового поля без пробелов
            String text = txtCustLimit.Text.Trim();
            txtCustLimit.Text = text; // Сохраняем без пробелов для удобства
            oleDbSelectCommand1.Parameters[0].Value = text;// Устанавливаем значение параметра
    
            // Очищаем набор данных
            dataSet11.Clear();
    
            // Заполняем набор данных командой с новым значением параметра
            //oleDbDataAdapter1.Fill(dataSet11);
            SafeFill_1();
    
            // Устанавливаем курсор списка в конец
            listBox.SelectedIndex = listBox.Items.Count - 1;
        }
    
        private void txtCustLimit_KeyDown(object sender, KeyEventArgs e)
        {
            if (e.KeyCode == Keys.Enter)
                NewLoad();
        }
    
        private void listBox_SelectedIndexChanged(object sender, EventArgs e)
        {
            // Очистить второй набор данных
            dataSet21.Clear();
            // Если выбран элемент списка, заполнить второй набор
            if (listBox.SelectedIndex != -1)
            {
                oleDbSelectCommand2.Parameters[0].Value = listBox.SelectedValue;
                //oleDbDataAdapter2.Fill(dataSet21);
                SafeFill_2();
            }
        }
    
        private void txtCustomerID_KeyPress(object sender, KeyPressEventArgs e)
        {
            if(!checkEdit.Checked)
                e.Handled = true;
        }
    
        private void txtFax_KeyDown(object sender, KeyEventArgs e)
        {
            if(!checkEdit.Checked)
                e.Handled = true;
        }
    
        private void btnSave_Click(object sender, EventArgs e)
        {
            SaveRecord();
        }
    
        private void SaveRecord()
        {
            // Применить свойство формы типа BindingContext 
            // и вытолкнуть изменения со всех дочерних элементов формы, 
            // связанных с данными, в кэш набора данных для заданной таблицы 
            this.BindingContext[dataSet21, "Customers"].EndCurrentEdit();
    
            // Обновить данные в БД из кэша набора данных dataSet21 
            //oleDbDataAdapter2.Update(dataSet21, "Customers");
            SafeUpdate_2();
    
            // Принять изменения
            // (лишнее!!! - вызывается автоматически методом Update)
            //dataSet21.AcceptChanges();
    
            // Обновить первый набор данных и список listBox 
            // с сохранением позиции выделенного элемента списка
            // на случай, если вдруг редактировалось поле CompanyName,
            // отображаемое в списке 
            int index = listBox.SelectedIndex;
            NewLoad();
            int count = listBox.Items.Count - 1;
            index = index < count ? index : count; // Однострочный условный оператор
            listBox.SelectedIndex = index;
        }
    
        private void btnCancel_Click(object sender, EventArgs e)
        {
            // Вытолкнуть первоначальные данные из 
            // набора данных в поля редактирования
            this.BindingContext[dataSet21, "Customers"].CancelCurrentEdit();
        }
    
        private void btnAdd_Click(object sender, EventArgs e)
        {
            // Добавить пустую запись в набор и 
            // показать ее в элементах редактирования 
            this.BindingContext[dataSet21, "Customers"].AddNew();
        }
    
        private void btnDelete_Click(object sender, EventArgs e)
        {
            if (listBox.Items.Count <= 0)// Список пустой, удалять нечего
                return;
            // Отметить в наборе текущую запись как удаленную 
            int index = this.BindingContext[dataSet21, "Customers"].Position;
            this.BindingContext[dataSet21, "Customers"].RemoveAt(index);
    
            SaveRecord();// Записать изменения в БД
        }
    
        private void Form1_FormClosed(object sender, FormClosedEventArgs e)
        {
            SaveRecord();
        }
    
        private void SafeFill_1()
        {
            try // Обработка ощибок
            {
                // Заполняем набор данных настроенным адаптером данных 
                oleDbDataAdapter1.Fill(dataSet11);
            }
            catch (OleDbException ext)
            {
                string message = "Ошибка чтения данных из БД\n";
                string caption = "Ошибка обращения к БД";
                MessageBox.Show(String.Format(message + "Подробности: {0}", ext.Message),
                    caption, MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
            finally
            {
                oleDbConnection1.Close();
            }
        }
    
        private void SafeFill_2()
        {
            try // Обработка ощибок
            {
                // Заполняем набор данных настроенным адаптером данных 
                oleDbDataAdapter2.Fill(dataSet21);
            }
            catch (OleDbException ext)
            {
                string message = "Ошибка чтения данных из БД\n";
                string caption = "Ошибка обращения к БД";
                MessageBox.Show(String.Format(message + "Подробности: {0}", ext.Message),
                    caption, MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
            finally
            {
                oleDbConnection2.Close();
            }
        }
    
        private void SafeUpdate_2()
        {
            try // Обработка ощибок
            {
                // Обновить данные в БД из кэша набора данных dataSet21 
                oleDbDataAdapter2.Update(dataSet21, "Customers");
            }
            catch (OleDbException ext)
            {
                string message = "Ошибка записи данных в БД\n";
                string caption = "Ошибка обращения к БД";
                MessageBox.Show(String.Format(message + "Подробности: {0}", ext.Message),
                    caption, MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
            finally
            {
                oleDbConnection2.Close();
            }
        }
    }
}
